## How to

### VS Code Workspaces

You will need general understanding of how to work with vscode SkyrimSE workspaces and MO2.

Watch this video for a quick tutorial: https://www.youtube.com/playlist?list=PLektTyeQhBZftc72NrPFAZDZDYdMX3bAK.
As a bonus, the expected folder structure in this project follows the one in the video.

This setup works best with a minimal MO2 install where you create profile just for this mod and
only load the required mods as dependencies.

### BlazePatcher

To work with patch helper tool (`blaze`), you will need to compile it 
(because I don't like distributing raw executables).

Get rust from https://rustup.rs/, add it to your path (I believe the installer does that).

Get the BlazePatcher. Compile it with `cargo build --release`. You will find the executable
in `target\release\blaze.exe`. Put the executable in some convenient location or add it to your PATH.

Then use it do greatly simplify patching.

#### Checkout

To checkout mod script version, say, 100, run

```sh
blaze checkout 100
```

Then, edit scripts (try only to modify the scripts needed), compile them in vs code workspace. Test them in-game.
This whole mod is basically a MO2 patch at this point.

#### Commit

When you are happy, commit the changes:

```sh
blaze commit
```

This won't modify the original files, it will create a patch in `/Patches` where it will copy
only those scripts that were changed.

You can run checkout again, in that case it will checkout all original files, plus, apply the patches on top.

#### Publish

Creates a FOMOD installer where user can pick their original mod version when installing.

```sh
blaze publish
```

### Notes on additional files in this project

#### dev-config.toml

The blaze tool reads `dev-config.toml` that has mod-specific configuration.

```toml
scripts_path = "Scripts" # path to scripts as it is in original mod
sources_path = "Scripts\\Source" # path to sources as it is in original mod
decompiled_sources = "Scripts\\Dec" # where to put decompiled sources for some mods
should_decompile = true # should use decompiled sources instead of included sources? because some mods ship wrong source files
when_sources_missing = "SkipScript" # some mods ship more pex files than they use, what to do if source was not found
decompiler = "C:\\Skyrim\\Tools\\Champollion\\Champollion.exe" # path to decompiler on your system
mod_name = "Original Name"
release_name = "FluentEncounters_OriginalName"
release_title = "Fluent Encounters for Original Name"
release_major_version = 1 # this is for patch version, which is not very relevant for users
```

#### checkout.toml

Dev tool creates `checkout.toml` file when you have sources active in the mod. It contains
just mod version so that the `commit` command knows what to commit.

#### .gitignore

The line `/Ref/**/Dec/` will exclude decompiled sources from commits.